Panda3D

Classes | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
RenderEffects Class Reference

This represents a unique collection of RenderEffect objects that correspond to a particular renderable state. More...

`#include "renderEffects.h"`

Inheritance diagram for RenderEffects:

## Public Member Functions
| RenderEffects (const RenderEffects &copy)=delete
virtual | ~RenderEffects ()
| The destructor is responsible for removing the RenderEffects from the global set if it is there. More...
void | adjust_transform (CPT(TransformState) &net_transform, CPT(TransformState) &node_transform, const PandaNode *node) const
| Calls adjust_transform() on all effects. More...
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
| CPT (RenderEffects) add_effect(const RenderEffect *effect) const
| CPT (RenderEffects) remove_effect(TypeHandle type) const
| CPT (RenderEffects) xform(const LMatrix4 &mat) const
virtual | CPT (TransformState) prepare_flatten_transform(const TransformState *net_transform) const
void | cull_callback (CullTraverser *trav, CullTraverserData &data, CPT(TransformState) &node_transform, CPT(RenderState) &node_state) const
| Calls cull_callback() on all effects. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
int | find_effect (TypeHandle type) const
virtual TypeHandle | force_init_type ()
const RenderEffect * | get_effect (size_t n) const
| Returns the nth effect in the state. More...
const RenderEffect * | get_effect (TypeHandle type) const
size_t | get_num_effects () const
| Returns the number of separate effects indicated in the state. More...
virtual TypeHandle | get_type () const
bool | has_adjust_transform () const
| This function is provided as an optimization, to speed up the render-time checking for the existance of an effect with a compute_adjust_transform on this state. More...
bool | has_cull_callback () const
| This function is provided as an optimization, to speed up the render-time checking for the existance of an effect with a cull_callback on this state. More...
bool | has_decal () const
| This function is provided as an optimization, to speed up the render-time checking for the existance of a DecalEffect on this state. More...
bool | has_show_bounds () const
| This function is provided as an optimization, to speed up the render-time checking for the existance of a ShowBoundsEffect on this state. More...
bool | has_show_tight_bounds () const
| If has_show_bounds() returns true, this will return true if the ShowBoundsEffect in question requests showing a "tight" bound. More...
bool | is_empty () const
| Returns true if the state is empty, false otherwise. More...
bool | operator< (const RenderEffects &other) const
RenderEffects & | operator= (const RenderEffects &copy)=delete
const RenderEffect * | operator[] (size_t n) const
| Returns the nth effect in the state. More...
const RenderEffect * | operator[] (TypeHandle type) const
| Returns the effect in the state with the given type. More...
void | output (std::ostream &out) const
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
bool | safe_to_combine () const
bool | safe_to_transform () const
| Returns true if all of the effects in this set can safely be transformed, and therefore the complete set can be transformed, by calling xform(). More...
size_t | size () const
| Returns the number of separate effects indicated in the state. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypedWritable * | change_this (TypedWritable *old_ptr, BamReader *manager)
| Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired. More...
static | CPT (RenderEffects) make(const RenderEffect *effect)
static | CPT (RenderEffects) make(const RenderEffect *effect1
static | CPT (RenderEffects) make(const RenderEffect *effect1
static | CPT (RenderEffects) make(const RenderEffect *effect1
static | CPT (RenderEffects) make_empty()
static TypeHandle | get_class_type ()
static int | get_num_states ()
static void | init_states ()
| Make sure the global _states map is allocated. More...
static void | init_type ()
static void | list_states (std::ostream &out)
| Lists all of the RenderEffects in the cache to the output stream, one per line. More...
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type RenderEffects. More...
static bool | validate_states ()
| Ensures that the cache is still stored in sorted order. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
static const RenderEffect * | effect2
static const RenderEffect const RenderEffect * | effect3
static const RenderEffect const RenderEffect const RenderEffect * | effect4
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This represents a unique collection of RenderEffect objects that correspond to a particular renderable state.

You should not attempt to create or modify a RenderEffects object directly. Instead, call one of the make() functions to create one for you. And instead of modifying a RenderEffects object, create a new one.

Definition at line 41 of file renderEffects.h.

## Constructor & Destructor Documentation

## ◆ ~RenderEffects()

RenderEffects::~RenderEffects | ( |  | ) |
| virtual

The destructor is responsible for removing the RenderEffects from the global set if it is there.

Definition at line 55 of file renderEffects.cxx.

## Member Function Documentation

## ◆ adjust_transform()

void RenderEffects::adjust_transform | ( | CPT(TransformState) & | net_transform,
|  | CPT(TransformState) & | node_transform,
|  | const PandaNode * | node
| ) |  | const

Calls adjust_transform() on all effects.

You may check has_adjust_transform() first to see if any effects define this method to do anything useful.

The order in which the individual effects are applied is not defined, so if more than one effect applies a change to the transform on any particular node, you might get indeterminate results.

Definition at line 476 of file renderEffects.cxx.

References ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ change_this()

TypedWritable * RenderEffects::change_this | ( | TypedWritable * | old_ptr,
|  | BamReader * | manager
| ) |  |
| static

Called immediately after complete_pointers(), this gives the object a chance to adjust its own pointer if desired.

Most objects don't change pointers after completion, but some need to.

Once this function has been called, the old pointer will no longer be accessed.

Definition at line 743 of file renderEffects.cxx.

## ◆ complete_pointers()

int RenderEffects::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager
| ) |  |
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

Reimplemented from TypedWritable.

Definition at line 687 of file renderEffects.cxx.

## ◆ cull_callback()

void RenderEffects::cull_callback | ( | CullTraverser * | trav,
|  | CullTraverserData & | data,
|  | CPT(TransformState) & | node_transform,
|  | CPT(RenderState) & | node_state
| ) |  | const

Calls cull_callback() on all effects.

You may check has_cull_callback() first to see if any effects define this method to do anything useful.

Definition at line 457 of file renderEffects.cxx.

Referenced by CullTraverserData::apply_transform_and_state().

## ◆ finalize()

void RenderEffects::finalize | ( | BamReader * | manager | ) |
| virtual

Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.

Reimplemented from TypedWritable.

Definition at line 768 of file renderEffects.cxx.

References unref().

## ◆ get_effect()

const RenderEffect * RenderEffects::get_effect | ( | size_t | n | ) | const
| inline

Returns the nth effect in the state.

Definition at line 110 of file renderEffects.I.

## ◆ get_num_effects()

size_t RenderEffects::get_num_effects | ( |  | ) | const
| inline

Returns the number of separate effects indicated in the state.

Definition at line 102 of file renderEffects.I.

## ◆ has_adjust_transform()

bool RenderEffects::has_adjust_transform | ( |  | ) | const
| inline

This function is provided as an optimization, to speed up the render-time checking for the existance of an effect with a compute_adjust_transform on this state.

Definition at line 208 of file renderEffects.I.

## ◆ has_cull_callback()

bool RenderEffects::has_cull_callback | ( |  | ) | const
| inline

This function is provided as an optimization, to speed up the render-time checking for the existance of an effect with a cull_callback on this state.

Definition at line 193 of file renderEffects.I.

Referenced by CullTraverserData::apply_transform_and_state().

## ◆ has_decal()

bool RenderEffects::has_decal | ( |  | ) | const
| inline

This function is provided as an optimization, to speed up the render-time checking for the existance of a DecalEffect on this state.

It returns true if a DecalEffect exists, false otherwise. Note that since there is no additional information stored on the DecalEffect, there's no point in returning it if it exists.

Definition at line 148 of file renderEffects.I.

## ◆ has_show_bounds()

bool RenderEffects::has_show_bounds | ( |  | ) | const
| inline

This function is provided as an optimization, to speed up the render-time checking for the existance of a ShowBoundsEffect on this state.

It returns true if a ShowBoundsEffect exists, false otherwise. Note that since there is no additional information stored on the ShowBoundsEffect, there's no point in returning it if it exists.

Definition at line 165 of file renderEffects.I.

## ◆ has_show_tight_bounds()

bool RenderEffects::has_show_tight_bounds | ( |  | ) | const
| inline

If has_show_bounds() returns true, this will return true if the ShowBoundsEffect in question requests showing a "tight" bound.

Definition at line 179 of file renderEffects.I.

## ◆ init_states()

void RenderEffects::init_states | ( |  | ) |
| static

Make sure the global _states map is allocated.

This only has to be done once. We could make this map static, but then we run into problems if anyone creates a RenderEffects object at static init time; it also seems to cause problems when the Panda shared library is unloaded at application exit time.

Definition at line 493 of file renderEffects.cxx.

Referenced by init_libpgraph().

## ◆ is_empty()

bool RenderEffects::is_empty | ( |  | ) | const
| inline

Returns true if the state is empty, false otherwise.

Definition at line 93 of file renderEffects.I.

## ◆ list_states()

void RenderEffects::list_states | ( | std::ostream & | out | ) |
| static

Lists all of the RenderEffects in the cache to the output stream, one per line.

This can be quite a lot of output if the cache is large, so be prepared.

Definition at line 402 of file renderEffects.cxx.

## ◆ operator[]() [1/2]

const RenderEffect * RenderEffects::operator[] | ( | size_t | n | ) | const
| inline

Returns the nth effect in the state.

Definition at line 127 of file renderEffects.I.

## ◆ operator[]() [2/2]

const RenderEffect * RenderEffects::operator[] | ( | TypeHandle | type | ) | const
| inline

Returns the effect in the state with the given type.

Definition at line 136 of file renderEffects.I.

## ◆ register_with_read_factory()

void RenderEffects::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type RenderEffects.

Definition at line 658 of file renderEffects.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libpgraph().

## ◆ require_fully_complete()

bool RenderEffects::require_fully_complete | ( |  | ) | const
| virtual

Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.

If this is the case, override this method to return true, and be careful with circular references (which would make the object unreadable from a bam file).

Reimplemented from TypedWritable.

Definition at line 724 of file renderEffects.cxx.

## ◆ safe_to_transform()

bool RenderEffects::safe_to_transform | ( |  | ) | const

Returns true if all of the effects in this set can safely be transformed, and therefore the complete set can be transformed, by calling xform().

Definition at line 68 of file renderEffects.cxx.

References ordered_vector< Key, Compare, Vector >::begin(), and ordered_vector< Key, Compare, Vector >::end().

## ◆ size()

size_t RenderEffects::size | ( |  | ) | const
| inline

Returns the number of separate effects indicated in the state.

Definition at line 119 of file renderEffects.I.

## ◆ unref()

virtual bool RenderEffects::unref | ( |  | ) | const
| virtual

Explicitly decrements the reference count.

Note that the object will not be implicitly deleted by unref() simply because the reference count drops to zero. (Having a member function delete itself is problematic.) However, see the helper function unref_delete().

User code should avoid using ref() and unref() directly, which can result in missed reference counts. Instead, let a PointerTo object manage the reference counting automatically.

This function is const, even though it changes the object, because generally fiddling with an object's reference count isn't considered part of fiddling with the object. An object might be const in other ways, but we still need to accurately count the number of references to it.

The return value is true if the new reference count is nonzero, false if it is zero.

Reimplemented from ReferenceCount.

Referenced by finalize().

## ◆ validate_states()

bool RenderEffects::validate_states | ( |  | ) |
| static

Ensures that the cache is still stored in sorted order.

Returns true if so, false if there is a problem (which implies someone has modified one of the supposedly-const RenderEffects objects).

Definition at line 417 of file renderEffects.cxx.

## ◆ write_datagram()

void RenderEffects::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  |
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Definition at line 667 of file renderEffects.cxx.

References ordered_vector< Key, Compare, Vector >::size(), and TypedWritable::write_datagram().

The documentation for this class was generated from the following files:

- panda/src/pgraph/renderEffects.h
- panda/src/pgraph/renderEffects.cxx
- panda/src/pgraph/renderEffects.I